#ifndef _TYPES_H
#define _TYPES_H

/*
 * SCCSID("@(#)types.h	7.3 (92/01/15)");
 *
 * (c) 1985 ACE	Associated Computer Experts bv,
 *		Amsterdam,
 *		The Netherlands.
 */

#ifndef NOTDEFINED
typedef unsigned char	byte;
typedef unsigned int	uint;
typedef unsigned short	ushort;
typedef unsigned long	ulong;

typedef long	daddr_t;  	/* disk address */
typedef	char *	paddr_t;	/* Physical address */
typedef char *	caddr_t;  	/* core address */
typedef char *	uaddr_t;  	/* user address */
typedef ushort	ino_t;     	/* i-node number */
#include <sys/time_t.h>
typedef short	dev_t;		/* device code */
typedef long	off_t;    	/* offset in file */
#include <sys/size_t.h>
#include <sys/clock_t.h>
typedef ushort	gid_t;		/* group IDs */
typedef ushort	pid_t;		/* process IDs */
typedef ushort	uid_t;		/* user IDs */
typedef ushort	mode_t;		/* file attributes */
typedef ushort	nlink_t;	/* link counts */

typedef ushort	pri_t;		/* priority type */
typedef ushort	id_t;		/* identification type */
typedef long	key_t;		/* key to a semaphore or message queue */
typedef long	reg_t;		/* the register type variable */
typedef ushort	imode_t;	/* type of i_mode */
typedef ulong	clkl_t;		/* length variables in clicks */
typedef ulong	clka_t;		/* address expressed in clicks. */
typedef ulong	swpl_t;		/* length in swap blocks */
typedef ulong	swpb_t;		/* the type of a swapblock number,
				 * i.e. blocknumber relative to
				 * swplo.
				 */

/*
 * Combination of all standard types. (used by access of dontcare).
 */
union	combin {
	char	chr;
	byte	bt;
	short	shrt;
	ushort	ushrt;
	long	lng;
	ulong	ulng;
} ;

/*
 * Vector table used to initialize vector areas
 */
struct vector {
	short	number;
	caddr_t	pointer;
} ;
/* 	The following definitions were added to XPDS/usr/include/sys/types.h
	to support X11
*/
typedef	unsigned char	u_char;
typedef	unsigned short	u_short;
typedef	unsigned int	u_int;
typedef	unsigned long	u_int32;
typedef	unsigned long	u_long;
#endif /* NOTDEFINED */


#define	NBBY	8		/* number of bits in a byte */
/*
 * Select uses bit masks of file descriptors in longs.
 * These macros manipulate such bit fields (the filesystem macros use chars).
 * FD_SETSIZE may be defined by the user, but the default here
 * should be >= NOFILE (param.h).
 */
#ifndef	FD_SETSIZE
#define	FD_SETSIZE	256
#endif

typedef	long	fd_mask;
#define	NFDBITS	(sizeof (fd_mask) * NBBY)	/* bits per mask */
#ifndef	howmany
#ifdef	sun386
#define	howmany(x, y)   ((((u_int)(x))+(((u_int)(y))-1))/((u_int)(y)))
#else
#define	howmany(x, y)	(((x)+((y)-1))/(y))
#endif
#endif

typedef	struct fd_set {
	fd_mask	fds_bits[howmany(FD_SETSIZE, NFDBITS)];
} fd_set;


#define	FD_SET(n, p)	((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
#define	FD_CLR(n, p)	((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
#define	FD_ISSET(n, p)	((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
#define	FD_ZERO(p)	bzero((char *)(p), sizeof (*(p)))

#endif /* _TYPES_H */
